Preparing for an interview? Check out Cracking the Coding Interview
Published on

Meta E5 Infra Engineer | New York | YOE: 8 | Reject

Author
  • Shared Anonymously

Got a call from the recruiter in January (Don't remember how did I apply but it was not referral).
I asked her for 6 weeks preparation time and screening round was scheduled for 13th March.
I started grinding so hard and did around 250 LC questions and went through a lot of system design videos and notes (source mentioned later). I had all my hopes on Meta instead of applying for other jobs. I Started having anxiety and panic attacks, then I rescheduled to 17th March.
Had a mock interview and the questions were quite Easy.

  1. Building with Ocean View https://leetcode.com/problems/buildings-with-an-ocean-view/
  2. Find max sum of all nodes
    Did both of them with good explanation within 25 minutes.

Then I finally had my screening round on 17th March and got these 2 questions:

  1. https://leetcode.com/problems/minimum-remove-to-make-valid-parentheses/description/
    Explained and coded stack approach. He then asked to optimise the space complexity and I explained the two loops approach but then he asked for 1 loop and I couldn't. He gave me hints that took 5 minutes and at last I just said I got it and coded it wrongly, but he said it is right. 25 minutes passed.
  2. https://leetcode.com/problems/kth-largest-element-in-an-array/description/
    Explained both priority queue and select sort and coded select sort within next 15 minutes.
    Did a dry run with both the questions at the end. (I made sure I give them all 4 coding signals)

Got feedback in few days that I did excelllent. And then next rounds were scheduled for end of April (almost a month).
Couldn't study for next 3 weeks due to health issues. Started revising again in the last week and finally had my first coding round of the loop and this is where I didn't do that well.

  1. https://leetcode.com/problems/custom-sort-string/description/
    I explained the map approach where I put characters of order in the map and coded and verified perfectly however I spent a lot of time explaining the solution and hence I didn't have much time left for second question. He asked for optimization (which was to count characters of s and not order) but I couldn't think of it due to time pressure and he moved on to second question.

  2. Merge 2 list of overlapping sorted intervals
    I explained the brute force and he said code it. I didn't have one part of solution clear in my mind but I started coding and I wrote some wrong logic towards the end of the code. I started verification process and but didn't write the variables clearly so he asked me to write and then run through the program. I did however I couldn't explain the edge cases. He said time's over.

4 days later I had rest 3 rounds, and firstly I had my 2nd coding round and it went good.

  1. https://leetcode.com/problems/subsets/description/
    There were letters instead of numbers. I explained the recursive approach using pencil and creating tree. He was fine with the approach and asked for time complexity and I expalined both time and space complexity and coded the solution with next 5 minutes. He said it would have repeatable subsets but then I did verification with an example and he got my solution and said it is good.

  2. https://leetcode.com/problems/random-pick-with-weight
    A slight variation with weights as cities' population. I explained the brute force and then prefix sum. However, I stuck for a minute on selecting the weight after creating the prefix sum array and he helped me & I got it immediately. Then he asked for optimization and he again gave me a hint that the prefix array is sorted and I said yes we can use binary search instead. He said yes thats what I wanted to hear.

Next was design round.
Design a 7-days long coding contest with 20 algorithmic questions.
I led the whole discussion and she was quiet the whole time. I kept asking about my assumptions and she was fine with almost everything except one point (I forgot to consider the peak load during capacity estimations). Overall I felt I did very well except capacity estimations.
I designed this:
image

At last I had behavioral round and the guy asked me usual questions like "conflicting priorities with manager", "a time when you experimented", "a tough person you worked with", etc.

Got a call from recruiter around 4 days later that there were not enough signals to proceed.

System design sources:
https://www.youtube.com/@SystemDesignInterview
https://www.youtube.com/@jordanhasnolife5163
https://github.com/preslavmihaylov/booknotes/tree/master/system-design/system-design-interview/

Thanks.

ReportMark as Helpful